cv <- function(svm.tr, lgp.tr, mars.tr, ALL.tr, Y.tr){	

	Jcv.svm_mean <- NULL
	Jcv.lgp_mean <- NULL
	Jcv.mars_mean <- NULL
	Jcv.ALL_mean <- NULL

	#Compute the size of the cross validation
	# =======================================
	index=sample(1:dim(svm.tr)[1])
	size.CV<-floor(dim(svm.tr)[1]/10)

	
	Jcv.svm <- NULL
	Jcv.lgp <- NULL
	Jcv.mars <- NULL
	Jcv.ALL <- NULL
	
	
	svm.tr <- scale(svm.tr)
	
	#Start 10-fold Cross validation
	# =============================
	for (i in 1:10) {
		# 	if m is the size of the training set 
		#	(nr of rows in svm.tr for example)
		#	take n observations for test and (m-n) for training
		#	with n << m (here n = m/10)
		# ===================================================
		i.ts<-(((i-1)*size.CV+1):(i*size.CV))	
		i.tr<-setdiff(index,i.ts)
				
		Y.tr.tr <- as.factor(Y.tr[i.tr])	
		Y.tr.ts <- as.factor(matrix(Y.tr[i.ts],ncol=1))

		svm.tr.tr <- svm.tr[i.tr,]
		svm.tr.ts <- svm.tr[i.ts,]	
					
		lgp.tr.tr <- lgp.tr[i.tr,]
		lgp.tr.ts <- lgp.tr[i.ts,]
		
		mars.tr.tr <- mars.tr[i.tr,]
		mars.tr.ts <- mars.tr[i.ts,]
		
		ALL.tr.tr <- ALL.tr[i.tr,]
		ALL.tr.ts <- ALL.tr[i.ts,]	
		
		# Get the model for the algorithms 
		# ==============================================

		#model.svm <- randomForest(svm.tr.tr,Y.tr.tr)
		#model.lgp <- randomForest(Y.tr.tr~.,lgp.tr.tr, importance=TRUE)
		#model.mars <- randomForest(Y.tr.tr~.,mars.tr.tr)
		#model.ALL <- randomForest(Y.tr.tr~.,ALL.tr.tr)
		
		#model.svm <- rpart(Y.tr.tr~.,svm.tr.tr)
		#model.lgp <- rpart(Y.tr.tr~.,lgp.tr.tr)
		#model.mars <- rpart(Y.tr.tr~.,mars.tr.tr)
		#model.ALL <- rpart(Y.tr.tr~.,ALL.tr.tr)
				
		#model.svm <- tree(Y.tr.tr~.,svm.tr.tr)
		#model.lgp <- tree(Y.tr.tr~.,lgp.tr.tr)
		#model.mars <- tree(Y.tr.tr~.,mars.tr.tr)
		#model.ALL <- tree(Y.tr.tr~.,ALL.tr.tr)

		
		model.svm <- svm(Y.tr.tr~.,svm.tr.tr,type="C-classification")
		#model.lgp <- svm(Y.tr.tr~.,lgp.tr.tr)
		#model.mars <- svm(Y.tr.tr~.,mars.tr.tr)
		#model.ALL <- svm(Y.tr.tr~.,ALL.tr.tr,type="C-classification")
		
		print(model.svm)
		
		# Compute the prediction 
		# ==============================================
		Y.hat.ts.svm <- predict(model.svm,svm.tr.ts)
		#Y.hat.ts.lgp <- predict(model.lgp,lgp.tr.ts)
		#Y.hat.ts.mars <- predict(model.mars,mars.tr.ts)
		#Y.hat.ts.ALL <- predict(model.ALL,ALL.tr.ts)
		
		# Compute the error 
		# ==============================================

		h.svm <- NULL
		h.lgp <- NULL
		h.mars <- NULL
		h.ALL <- NULL
		
		CART = F
		
		if(CART){
			h.svm <- matrix(nrow=dim(Y.hat.ts.svm)[1],ncol=1)
			h.lgp <- matrix(nrow=dim(Y.hat.ts.svm)[1],ncol=1)
			h.mars <- matrix(nrow=dim(Y.hat.ts.svm)[1],ncol=1)
			h.ALL <- matrix(nrow=dim(Y.hat.ts.svm)[1],ncol=1)
			
			for(j in 1:dim(Y.hat.ts.svm)[1]){ 
				h.svm[j] <- names(which.max(Y.hat.ts.svm[j,]))
			}
			
			for(j in 1:dim(Y.hat.ts.svm)[1]){ 
				h.lgp[j] <- names(which.max(Y.hat.ts.lgp[j,]))
			}
			
			for(j in 1:dim(Y.hat.ts.svm)[1]){ 
				h.mars[j] <- names(which.max(Y.hat.ts.mars[j,]))
			}
			
			for(j in 1:dim(Y.hat.ts.svm)[1]){ 
				h.ALL[j] <- names(which.max(Y.hat.ts.ALL[j,]))
			}
		}
		else{
			h.svm <- matrix(Y.hat.ts.svm,ncol=1)
			#h.lgp <- matrix(Y.hat.ts.lgp,ncol=1)
			#h.mars <- matrix(Y.hat.ts.lgp,ncol=1)
			#h.ALL <- matrix(Y.hat.ts.ALL,ncol=1)
		}
		#print(cbind(Y.hat.ts.svm,Y.tr.ts,h))
		#print(dim(Y.hat.ts.svm))
		#print(size.CV)
								
		Jcv.svm <- c(Jcv.svm ,sum(!(h.svm == Y.tr.ts))/size.CV)
		print(table(h.svm,Y.tr.ts))	
		print(Jcv.svm)				
		
		#Jcv.lgp <- c(Jcv.lgp ,sum(!(h.lgp == Y.tr.ts))/size.CV)
		#print(table(h.lgp,Y.tr.ts))	
		#print(Jcv.lgp)
						
		#Jcv.mars <- c(Jcv.mars ,sum(!(h.mars == Y.tr.ts))/size.CV)
		#print(table(h,Y.tr.ts))			
					
		#Jcv.ALL <- c(Jcv.ALL ,sum(!(h.ALL == Y.tr.ts))/size.CV)
		#print(table(h.ALL,Y.tr.ts))	
		#print(Jcv.ALL)
	}
	
	Jcv.svm_mean <- c(Jcv.svm_mean, mean(Jcv.svm))
	#Jcv.lgp_mean <- c(Jcv.lgp_mean, mean(Jcv.lgp))
	#Jcv.mars_mean <- c(Jcv.mars_mean, mean(Jcv.mars))
	#Jcv.ALL_mean <- c(Jcv.ALL_mean, mean(Jcv.ALL))
	
	d <- 10
	print(paste("Jcv.svm_mean: ", round(Jcv.svm_mean,digits=d) ))
	#print(paste("Jcv.lgp_mean: ", round(Jcv.lgp_mean,digits=d) ))
	#print(paste("Jcv.mars_mean: ", round(Jcv.mars_mean,digits=d) ))
	#print(paste("Jcv.ALL_mean: ", round(Jcv.ALL_mean,digits=d) ))

	
	#plot(training_size,Jcv.svm_mean,main="Cross Validation Error for with svm against training set size", xlab="training_size",ylab="Error",col="red",type="l") 
  	#par(c(1,1))
  	#plot(training_size,Jcv.lgp_mean, col="green",type="l")
  	
  	
}
