print("Getting training data...")

training <- read.table("kddcup2.data",sep=",",header=T)

#		Transform the non-numerical features into numerical ones
#######################################################################
non_numerical_features <- c("protocol_type","service","flag")
nb_protocol_types <- length(unique(training[,non_numerical_features[1]]))
nb_services <- length(unique(training[,non_numerical_features[2]]))
nb_flags <- length(unique(training[,non_numerical_features[3]]))


training2 <- within(training, c(protocol_type <- factor(protocol_type, labels = c(1:nb_protocol_types)),service <-factor(service, labels = c(1:nb_services)),flag <-factor(flag, labels = c(1:nb_flags))))


print("Training data acquired...")

u2r <- training[training["label"] == "buffer_overflow." | training["label"] == "loadmodule." | training["label"] == "perl." | training["label"] == "rootkit.",]
write.table(u2r,file="kddcup_u2r.data",col.names=T,quote=F,append=F,sep=",",row.names=F)

print("u2r finished...")

r2l <- training[training["label"] == "ftp_write." | training["label"] == "guess_passwd." | training["label"] == "imap." | training["label"] == "multihop." | training["label"] == "phf." | training["label"] == "spy." | training["label"] == "warezclient." | training["label"] == "warezmaster.",]
write.table(r2l,file="kddcup_r2l.data",col.names=T,quote=F,append=F,sep=",",row.names=F)

print("r2l finished...")

probe <- training[training["label"] == "ipsweep." | training["label"] == "nmap." | training["label"] == "portsweep." | training["label"] == "satan.",]
write.table(probe,file="kddcup_probe.data",col.names=T,quote=F,append=F,sep=",",row.names=F)

print("probe finished...")

normal <- training[training["label"] == "normal.",]
write.table(normal,file="kddcup_normal.data",col.names=T,quote=F,append=F,sep=",",row.names=F)

print("normal finished...")

dos <- training[training["label"] == "back." | training["label"] == "land." | training["label"] == "neptune." | training["label"] == "pod." | training["label"] == "smurf." | training["label"] == "teardrop.",]
write.table(dos,file="kddcup_dos.data",col.names=T,quote=F,append=F,sep=",",row.names=F)

print("dos finished...")