print("Getting test data...")

#test <- read.table("corrected2.data",sep=",",header=T)

#		Transform the non-numerical features into numerical ones
#######################################################################
non_numerical_features <- c("protocol_type","service","flag")
nb_protocol_types <- length(unique(test[,non_numerical_features[1]]))
#nb_services <- length(unique(test[,non_numerical_features[2]]))
nb_flags <- length(unique(test[,non_numerical_features[3]]))


#print(dim(test[!test["service"] == "icmp",]))
#test = test[!test["service"] == "icmp",]

#for (i in sort(unique(test[,"service"])))
#	services <- c(services, which( i == sort(unique(training[,"service"])),arr.ind=TRUE)))

test <- within(test, c(protocol_type <- factor(protocol_type, labels = c(1:nb_protocol_types)),service <-factor(service, labels = c(2:19,21:22,24,26:48,50:62,64:70)),flag <-factor(flag, labels = c(1:nb_flags))))


print("Test data acquired...")

u2r <- test[test["label"] == "buffer_overflow." | test["label"] == "loadmodule." | test["label"] == "perl." | test["label"] == "rootkit." | test["label"] == "ps." | test["label"] == "xterm." | test["label"] == "sqlattack.",]
write.table(u2r,file="test_u2r.data",col.names=T,quote=F,append=F,sep=",",row.names=F)

print("u2r finished...")

r2l <- test[test["label"] == "ftp_write." | test["label"] == "guess_passwd." | test["label"] == "imap." | test["label"] == "multihop." | test["label"] == "phf." | test["label"] == "spy." | test["label"] == "warezclient." | test["label"] == "warezmaster." | test["label"] == "xlock." | test["label"] == "snmpgetattack." | test["label"] == "httptunnel." | test["label"] == "named." | test["label"] == "sendmail." | test["label"] == "snmpguess." | test["label"] == "worm." | test["label"] == "xsnoop.",]
write.table(r2l,file="test_r2l.data",col.names=T,quote=F,append=F,sep=",",row.names=F)

print("r2l finished...")

probe <- test[test["label"] == "ipsweep." | test["label"] == "nmap." | test["label"] == "portsweep." | test["label"] == "satan." | test["label"] == "mscan." | test["label"] == "saint.",]
write.table(probe,file="test_probe.data",col.names=T,quote=F,append=F,sep=",",row.names=F)

print("probe finished...")

normal <- test[test["label"] == "normal.",]
write.table(normal,file="test_normal.data",col.names=T,quote=F,append=F,sep=",",row.names=F)

print("normal finished...")

dos <- test[test["label"] == "back." | test["label"] == "land." | test["label"] == "neptune." | test["label"] == "pod." | test["label"] == "smurf." | test["label"] == "teardrop." | test["label"] == "udpstorm." | test["label"] == "apache2." | test["label"] == "mailbomb." | test["label"] == "processtable.",]
write.table(dos,file="test_dos.data",col.names=T,quote=F,append=F,sep=",",row.names=F)

print("dos finished...")